%define real_version 2.1_3
%define without_hook 1
Name:          cglib21
Version:       2.1.3
Release:       %mkrel 0
Summary:       Code Generation Library
Group:         Development/Java
License:       ASL
Url:           http://cglib.sourceforge.net/
Source0:       http://sourceforge.net/projects/cglib/files/cglib2/cglib%20%{real_version}/cglib-src-%{real_version}.jar
Source1:       http://repo1.maven.org/maven2/cglib/cglib/%{real_version}/cglib-%{real_version}.pom
Source2:       http://repo1.maven.org/maven2/cglib/cglib-nodep/%{real_version}/cglib-nodep-%{real_version}.pom
Source3:       cglib-%{real_version}-missing-words.txt
Patch0:        cglib-2.1.3-build_xml.patch
Patch1:        cglib-2.1.3-ExamplePreProcessor.patch
Patch2:        cglib-2.1.3-TestEnhancer.patch
Patch3:        cglib-2.1.3-compilesource.patch
BuildRequires: ant
BuildRequires: ant-junit
BuildRequires: asm
%if !%without_hook
# TODO
BuildRequires: aspectwerkz
%endif
BuildRequires: jarjar
BuildRequires: java-devel
BuildRequires: junit
BuildRequires: jpackage-utils
Requires:      asm
%if !%without_hook
Requires:      aspectwerkz
%endif
Requires:      jpackage-utils
BuildArch:     noarch
BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Byte Code Generation Library is high level API to generate and transform JAVA byte code.
It is used by AOP, testing, data access frameworks to generate dynamic proxy objects and
intercept field access.

%package javadoc
Group:          Documentation
Summary:        Javadoc for %{name}

%description javadoc
Byte Code Generation Library is high level API to generate and transform JAVA byte code.
It is used by AOP, testing, data access frameworks to generate dynamic proxy objects and
intercept field access.

This package contains documentation for %{name}.

%package demo
Group:          Documentation
Summary:        Samples for %{name}

%description demo
Byte Code Generation Library is high level API to generate and transform JAVA byte code.
It is used by AOP, testing, data access frameworks to generate dynamic proxy objects and
intercept field access.

This package contains documentation and samples for %{name}.

%prep
%setup -q -c

for j in $(find . -name "*.jar"); do
  mv $j ${j}.no
done

cp %{S:1} src/test/net/sf/cglib/util/words.txt

%patch0 -p0
#% if !%without_hook
%patch1 -p0
#% endif
%patch2 -p0
%patch3 -p0

pushd lib
  build-jar-repository -p . ant junit asm/asm asm/asm-attrs asm/asm-util jarjar
%if !%without_hook
  ln -s $(build-classpath aspectwerkz-core) aspectwerkz-core-0.10.RC1.jar
%else
  mv aspectwerkz-core-0.10.RC1.jar.no aspectwerkz-core-0.10.RC1.jar
%endif
popd
#% if %without_hook
#  rm src/proxy/net/sf/cglib/transform/hook/*
#  rm src/test/net/sf/cglib/transform/hook/*
#% endif
perl -pi -e 's/\r$//g' LICENSE

%build

export CLASSPATH=
CLASSPATH=$CLASSPATH:dist/cglib-nodep-%{real_version}.jar:dist/cglib-%{real_version}.jar
ant jar javadoc

#% if !%without_hook
mkdir _tmp
pushd _tmp
  cp -pr ../dist/cglib-2.1_3.jar .
  jar xf cglib-2.1_3.jar
  rm -rf net/sf/cglib/transform/hook
  jar cmf META-INF/MANIFEST.MF cglib21-nohook-2.1_3.jar  net
  mv cglib21-nohook-2.1_3.jar ../dist/
popd
rm -rf _tmp
#% endif

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_javadir}
install -pm 644 dist/cglib-2.1_3.jar \
  %{buildroot}%{_javadir}/cglib21-%{version}.jar
install -pm 644 dist/cglib-nodep-2.1_3.jar \
  %{buildroot}%{_javadir}/cglib21-nodep-%{version}.jar
install -pm 644 dist/cglib21-nohook-2.1_3.jar \
  %{buildroot}%{_javadir}/cglib21-nohook-%{version}.jar

mkdir -p %{buildroot}%{_mavenpomdir}
install -m 644 %{SOURCE1} %{buildroot}%{_mavenpomdir}/JPP-cglib21.pom
%add_to_maven_depmap cglib cglib 2.1_3 JPP cglib21
%add_to_maven_depmap cglib cglib %{version} JPP cglib21
install -m 644 %{SOURCE2} %{buildroot}%{_mavenpomdir}/JPP-cglib21-nodep.pom
%add_to_maven_depmap cglib cglib-nodep 2.1_3 JPP cglib21-nodep
%add_to_maven_depmap cglib cglib-nodep %{version} JPP cglib21-nodep

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}.jar; do
    ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`
  done
)

mkdir -p %{buildroot}%{_javadocdir}/cglib21-%{version}
cp -pr docs/* %{buildroot}%{_javadocdir}/cglib21-%{version}
ln -s cglib21-%{version} %{buildroot}%{_javadocdir}/cglib21

mkdir -p %{buildroot}%{_datadir}/cglib21
cp -pr src/proxy/samples %{buildroot}%{_datadir}/cglib21

%clean
[ %{buildroot} != / ] && rm -rf %{buildroot}

%files
%defattr(-,root,root) 
%{_javadir}/cglib21-%{version}.jar
%{_javadir}/cglib21.jar
%{_javadir}/cglib21-nodep-%{version}.jar
%{_javadir}/cglib21-nodep.jar
%{_javadir}/cglib21-nohook-%{version}.jar
%{_javadir}/cglib21-nohook.jar
%{_mavenpomdir}/*
%{_mavendepmapfragdir}/*
%doc LICENSE NOTICE README

%files javadoc
%defattr(-,root,root)
%{_javadocdir}/cglib21-%{version}
%{_javadocdir}/cglib21

%files demo
%defattr(-,root,root)
%{_datadir}/cglib21



%changelog
* Wed Jun 15 2011 gil <gil> 2.1.3-0.mga2
+ Revision: 107669
- edit build requires
- imported package cglib21


* Wed Jun 15 2011 gil <gil> 2.1.3-0.%%mkrel
- initial rpm